!!FP1.0
#profile fp30
#program VolumeRenderingIntegratePartialPreIntegrationFrag
#semantic VolumeRenderingIntegratePartialPreIntegrationFrag.Incoming
#semantic VolumeRenderingIntegratePartialPreIntegrationFrag.PsiGammaTable
#var float4 input.WPos : $vin.WPOS : WPOS : 0 : 1
#var float3 input.BackColor : $vin.TEXCOORD0 : TEXCOORD0 : 0 : 1
#var float3 input.FrontColor : $vin.TEXCOORD1 : TEXCOORD1 : 0 : 1
#var float input.Length : $vin.TEXCOORD2 : TEXCOORD2 : 0 : 1
#var float2 input.Attenuation : $vin.TEXCOORD3 : TEXCOORD3 : 0 : 1
#var samplerRECT Incoming :  : texunit 0 : 1 : 1
#var samplerRECT PsiGammaTable :  : texunit 1 : 2 : 1
#var float4 Color : $vout.COLOR : COLOR : -1 : 1

#R0.xy = tau * length
MOVR R0.z, f[TEX2].x;
MULR R0.xy, f[TEX3].xyxx, R0.z;

#R1.y = zeta = e^(-.5(tauLength.x+tauLength.y))
ADDR R1.y, R0.x, R0.y;
MULR R1.y, {-0.5}.x, R1.y;
POWR R1.y, {2.7182817}.x, R1.y;

#R0.xy = gamma = tauLength/(tauLength+1)
ADDR R0.zw, R0.xxxy, {1}.x;
RCPR R0.z, R0.z;
RCPR R0.w, R0.w;
MULR R0.xy, R0.xyxx, R0.zwxx;

#R1.x = Psi.  R0 may be discarded.
#MULR R0.xy, R0.xyxx, {1024,1024}.xyxx;
MADR R0.xy, R0.xyxx, {1024,1024}.xyxx, {0.5}.x;
TEX R1.x, R0.xyxx, TEX1, RECT;

#R0 = Incoming*zeta
TEX R0, f[WPOS].xyxx, TEX0, RECT;
ADDR R1.z, R1.x, -R1.y;
MULR R0, R0, R1.y;

#o[COLR].a = R0.a + (1-zeta)
ADDR R0.w, R0.w, {1}.x;
ADDR o[COLR].w, R0.w, -R1.y;

#R0.rgb += BackColor*(Psi-zeta)
#ADDR R1.z, R1.x, -R1.y;
MADR R0.xyz, f[TEX0], R1.z, R0.xyzx;

#o[COLR].rgb = R0.rgb + FrontColor*(1-Psi)
ADDR R1.z, {1}.x, -R1.x;
MADR o[COLR].xyz, f[TEX1], R1.z, R0.xyzx;

END
