!!FP1.0
#profile fp30
#program VolumeRenderingIntegrateRiemannFrag
#semantic VolumeRenderingIntegrateRiemannFrag.Incoming
#var float4 input.WPos : $vin.WPOS : WPOS : 0 : 1
#var float4 input.BackColor : $vin.TEXCOORD0 : TEXCOORD0 : 0 : 1
#var float4 input.FrontColor : $vin.TEXCOORD1 : TEXCOORD1 : 0 : 1
#var float input.Length : $vin.TEXCOORD2 : TEXCOORD2 : 0 : 1
#var samplerRECT Incoming :  : texunit 0 : 1 : 1
#var float4 Color : $vout.COLOR : COLOR : -1 : 1

# R0 = incoming pixel.
TEX R0, f[WPOS].xyxx, TEX0, RECT;

# R2.x = -length/2
MULR R2.x, f[TEX2].x, {-0.5}.x;

# R1 = weighted color for back part of integral.
MULR R1, f[TEX0], {0.25}.x;
MADR R1, f[TEX1], {0.75}.x, R1;

# R1.a = weighted zeta
MULR R1.w, R1.w, R2.x;
POWR R1.w, {2.7182817}.x, R1.w;

# R0 = R0 * zeta
MULR R0, R0, R1.w;

# R1.a = weighted alpha
ADDR R1.w, -R1.w, {1}.x;

# R1.rgb *= alpha
MULR R1.xyz, R1.xyzx, R1.w;

#R0 += weighted and pre-multiplied color.
ADDR R0, R0, R1;

# R1 = weighted color for front part of integral.
MULR R1, f[TEX0], {0.75}.x;
MADR R1, f[TEX1], {0.25}.x, R1;

# R1.a = weighted zeta
MULR R1.w, R1.w, R2.x;
POWR R1.w, {2.7182817}.x, R1.w;

# R0 = R0 * zeta
MULR R0, R0, R1.w;

# R1.a = weighted alpha
ADDR R1.w, -R1.w, {1}.x;

# R1.rgb *= alpha
MULR R1.xyz, R1.xyzx, R1.w;

#o[COLR] = R0 + weighted and pre-multiplied color.
ADDR o[COLR], R0, R1;

END
