// -*- c++ -*- *******************************************************
// Copyright (C) 2003 Sandia Corporation
// Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that this Notice and any statement
// of authorship are reproduced on all copies.
//
// $Id: ocaCgError.h,v 1.2 2003-06-30 17:56:01 kmorel Exp $

// Exception class to be thrown on Cg error.

#ifndef _ocaCgError_h
#define _ocaCgError_h

#include "ocaError.h"

#include <Cg/cg.h>

class OCA_EXPORT ocaCgError : public ocaError
{
  public:
    inline CGerror getError() const { return this->cgErrorCode; }

    ocaCgError();
    ocaCgError(CGerror code);
    ocaCgError(CGerror code, CGcontext context);

  protected:
    CGerror cgErrorCode;
};

#endif //_ocaCgError_h
