// -*- c++ -*- *******************************************************
// Copyright (C) 2003 Sandia Corporation
// Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that this Notice and any statement
// of authorship are reproduced on all copies.
//
// $Id: ocaProgramComplexMatrixMultiply.h,v 1.3 2003-06-30 17:56:01 kmorel Exp $

#ifndef _ocaProgramComplexMatrixMultiply_h
#define _ocaProgramComplexMatrixMultiply_h

#include "ocaProgram.h"

class ocaLookUpBuffer;
class ocaDrawableBuffer;

class OCA_EXPORT ocaProgramComplexMatrixMultiply : public ocaProgram
{
  public:
    ocaProgramMacro(ComplexMatrixMultiply);

    void execute(ocaSmartPointer<ocaLookUpBuffer> matrixA,
		 ocaSmartPointer<ocaLookUpBuffer> matrixB,
		 ocaSmartPointer<ocaDrawableBuffer> destination,
		 ocaSmartPointer<ocaDrawableBuffer> temporary,
		 bool ARowIsT = true, bool BRowIsT = true,
		 bool DestRowIsY = true);
    void execute(ocaSmartPointer<ocaLookUpBuffer> matrixA,
		 ocaSmartPointer<ocaLookUpBuffer> matrixB,
		 ocaSmartPointer<ocaDrawableBuffer> destination,
		 bool ARowIsT = true, bool BRowIsT = true,
		 bool DestRowIsY = true);

  protected:
    CGparameter position;
    CGparameter index;
    CGparameter matrixA;
    CGparameter matrixB;
    CGparameter matrixACCUM;
};

#endif //_ocaProgramComplexMatrixMultiply_h
