// -*- c++ -*- *******************************************************
// Copyright (C) 2003 Sandia Corporation
// Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that this Notice and any statement
// of authorship are reproduced on all copies.
//
// $Id: ocaProgramFastMatrixMultiply.h,v 1.2 2003-06-30 17:56:02 kmorel Exp $

#ifndef _ocaProgramFastMatrixMultiply_h
#define _ocaProgramFastMatrixMultiply_h

#include "ocaProgram.h"

class ocaLookUpBuffer;
class ocaDrawableBuffer;

class OCA_EXPORT ocaProgramFastMatrixMultiply : public ocaProgram
{
  public:
    ocaProgramMacro(FastMatrixMultiply);

    void execute(ocaSmartPointer<ocaLookUpBuffer> matrixA,
		 ocaSmartPointer<ocaLookUpBuffer> matrixB,
		 ocaSmartPointer<ocaDrawableBuffer> destination,
		 ocaSmartPointer<ocaDrawableBuffer> temporary);
    void execute(ocaSmartPointer<ocaLookUpBuffer> matrixA,
		 ocaSmartPointer<ocaLookUpBuffer> matrixB,
		 ocaSmartPointer<ocaDrawableBuffer> destination);

  protected:
    CGparameter position;
    CGparameter matrixA;
    CGparameter matrixB;
    CGparameter matrixACCUM;
    CGparameter iteration;
};

#endif //_ocaProgramFastMatrixMultiply_h
