// -*- c++ -*- *******************************************************
// Copyright (C) 2003 Sandia Corporation
// Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that this Notice and any statement
// of authorship are reproduced on all copies.
//
// $Id: ocaProgramPassThrough.h,v 1.8 2003-06-30 17:56:02 kmorel Exp $

#ifndef _ocaProgramPassThrough_h
#define _ocaProgramPassThrough_h

#include "ocaProgram.h"

class ocaLookUpBuffer;
class ocaDrawableBuffer;

class OCA_EXPORT ocaProgramPassThrough : public ocaProgram
{
  public:
    ocaProgramMacro(PassThrough);

    void execute(ocaSmartPointer<ocaLookUpBuffer> src,
		 ocaSmartPointer<ocaDrawableBuffer> dest);
    void execute(ocaSmartPointer<ocaLookUpBuffer> src);

    inline CGparameter getPosition() { return position; }
    inline CGparameter getSource() { return source; }

  protected:
    CGparameter position;
    CGparameter source;
};

#endif //_ocaProgramPassThrough_h
