// -*- c++ -*- *******************************************************
// Copyright (C) 2003 Sandia Corporation
// Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that this Notice and any statement
// of authorship are reproduced on all copies.
//
// $Id: ocaProgramScale.h,v 1.2 2003-06-30 17:56:02 kmorel Exp $

#ifndef _ocaProgramScale_h
#define _ocaProgramScale_h

#include "ocaProgram.h"

class ocaLookUpBuffer;
class ocaDrawableBuffer;

class OCA_EXPORT ocaProgramScale : public ocaProgram
{
  public:
    ocaProgramMacro(Scale);

    void execute(ocaSmartPointer<ocaLookUpBuffer> src, float scale,
		 ocaSmartPointer<ocaDrawableBuffer> dest);

    inline CGparameter getPosition() { return position; }
    inline CGparameter getSource() { return source; }
    inline CGparameter getScale() { return scale; }

  protected:
    CGparameter position;
    CGparameter source;
    CGparameter scale;
};

#endif //_ocaProgramScale_h
