// -*- c++ -*- *******************************************************
// Copyright (C) 2003 Sandia Corporation
// Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that this Notice and any statement
// of authorship are reproduced on all copies.
//
// Solves the volume rendering equation with partial preintegration.
//
// $Id: ocaProgramVolumeRenderingIntegratePartialPreIntegration.h,v 1.1 2003-09-25 22:29:33 kmorel Exp $

#ifndef _ocaProgramVolumeRenderingIntegratePartialPreIntegration_h
#define _ocaProgramVolumeRenderingIntegratePartialPreIntegration_h

#include "ocaProgramVolumeRenderingIntegrate.h"

class ocaLookUpBuffer;

class OCA_EXPORT ocaProgramVolumeRenderingIntegratePartialPreIntegration
    : public ocaProgramVolumeRenderingIntegrate
{
  public:
    ocaProgramMacro(VolumeRenderingIntegratePartialPreIntegration);

    virtual void bind();
    virtual void unbind();

  protected:
    CGparameter PsiGammaTable;
    ocaSmartPointer<ocaLookUpBuffer> PsiGammaTableLookup;
};

#endif //_ocaProgramVolumeRenderingIntegratePartialPreIntegration_h
