// -*- c++ -*- *******************************************************
// Copyright (C) 2003 Sandia Corporation
// Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that this Notice and any statement
// of authorship are reproduced on all copies.
//
// $Id: ocaZeroBuffer.cxx,v 1.3 2003-06-30 17:56:02 kmorel Exp $

#include "ocaZeroBuffer.h"

#include "ocaFactory.h"

static float zero_vector[] = { 0.0, 0.0, 0.0, 0.0 };

ocaZeroBuffer::ocaZeroBuffer() : ocaLookUpBuffer(ocaFactory::getSingleton())
{
    this->size[0] = 1;
    this->size[1] = 1;
    this->vectorSize = 4;
    this->super::setData(zero_vector);
}

void ocaZeroBuffer::setData(float *) {
    ocaRaiseError("Cannot set zero lookup buffer.");
}

void ocaZeroBuffer::setData(float *, int, int, int) {
    ocaRaiseError("Cannot set zero lookup buffer.");
}
